#include <stdlib.h>
#include <ctype.h>
#include <errno.h>

#include <nllibc.h>

int atoi(const char *nptr)
{
  int i, n = 0;
  for (i = 0; nptr[i]; i++) {
    n *= 10;
    n += nptr[i] - '0';
  }
  return n;
}

long strtol(const char *nptr, char **endptr, int base)
{ 
  long val, value = 0;
  int sign = 1;

  if (endptr)
    *endptr = (char *)nptr;

  while (isspace(*nptr))
    nptr++;

  switch (nptr[0]) {
  case '+': sign =  1; nptr++; break;
  case '-': sign = -1; nptr++; break;
  default: break;
  }

  if (nptr[0] == '0') {
    nptr++;
    if ((nptr[0] == 'x') || (nptr[0] == 'X')) {
      nptr++;
      if (base == 0)
	base = 16;
      if (base != 16) {
	errno = EINVAL;
	return 0;
      }
    } else {
      if ((base == 0) || (!isdigit(nptr[0])))
	base = 8;
      if (base != 8) {
	errno = EINVAL;
	return 0;
      }
    }
  } else {
    if (base == 0)
      base = 10;
#if 0
    if (base != 10) {
      errno = EINVAL;
      return 0;
    }
#endif
  }

  for (; *nptr; nptr++) {
    if (isdigit(*nptr))
      val = *nptr - '0';
    else if (islower(*nptr))
      val = *nptr - 'a' + 10;
    else if (isupper(*nptr))
      val = *nptr - 'A' + 10;
    else
      break;

    if (val >= base)
      break;

    value = value * base + val;
  }

  if (sign < 0)
    value = -value;

  if (endptr)
    *endptr = (char *)nptr;

  return value;
}

unsigned long strtoul(const char *nptr, char **endptr, int base)
{
  return (unsigned long)strtol(nptr, endptr, base);
}
